#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h> 
#include <avr/signal.h>
#include <avr/sleep.h>

#include "nokialcd.c"  //mit .h geht es nicht? Makefileerror?

//------------------------------------Temperatursensor----------------------------------------
#include "onewire.h"
#include "ds18x20.h"
#include "delay.h"

//------------------------------------Globale Variablen---------------------------------------

unsigned char uCClockMhz=4;

bool Normalbetrieb=1,Akkufastleer=0;
int Solltemp=8,Isttemp=10;

bool blinken=0,displaychanged=1;
int blinkzaehler=0,i=0;

uint8_t subzero, cel, cel_frac_bits;

//--------------------------------Globale Variablen   Ende------------------------------------




volatile unsigned int count;

SIGNAL (SIG_OVERFLOW0) 
	{
	TCNT0+=130;
	count++;
	return;
	}	 

void timer_init (void) 
	{ 
		TIMSK = _BV(TOIE0);              //Timer Overflow Interrupt enable 
		TCNT0 = 130;                     //Rcksetzen des Timers 
		TCCR0 = _BV(CS01);               //Prescaler 8 
		sei (); 
	}

void display_power_down(void){		//Display Power-down mode enabled
LcdSend( 0b00100101, LCD_CMD );
}




void display_power_up(void){		//Ich wei nicht, welcher Befehl hier berflssig ist,
									//aber so geht es.
LcdSend( 0x21, LCD_CMD );  // LCD Extended Commands.
LcdSend( 0xC8, LCD_CMD );  // Set LCD Vop (Contrast).
LcdSend( 0x20, LCD_CMD );  // LCD Standard Commands, Horizontal addressing mode.
LcdSend( 0x0C, LCD_CMD );  // LCD in normal mode.
}

void delay_ms_mhz(unsigned int ms,unsigned char mhz){
	count=0;
	TCNT0 = 130;
	while(count<=(ms*mhz))
		{
		sleep_mode();
		}
	return;
}


		const char Satz1[] PROGMEM ="Solltemp.:  ^C ";
		const char Satz2[] PROGMEM ="Isttemp. :  ^C ";
		const char Satz3[] PROGMEM ="Peltier  :  ";
		const char Satz4[] PROGMEM ="Luefter  :  ";
		const char Celsius[] PROGMEM ="^C";
		const char Ein[] PROGMEM ="Ein";
		const char Aus[] PROGMEM ="Aus";

//Diese Funktion gibt eine Zeichenfolge (aus dem Flash)
//auf dem Display aus,
//wobei nach Leerzeichen gesucht wird und ggf. auf die 
//nchste Zeile umgebrochen wird. Bei Wrtern die lnger
//als eine Zeile sind, wird nicht umgebrochen.
//Mit cmin kann jedoch die Mindestanzahl von Buchstaben
//eines berlangen Wortes am Zeilenende bestimmt werden.
//Das letzte Zeichen mu ein Leerzeichen sein, damit
//beim letzten Wort auch noch richtig umgebrochen wird.
//
//Basierend auf nokialcd.c von Sylvain Bissonnette
//
//2004-12-19 Moritz
//
//Parameter:
//	x		: X Koordinate (1-14)
//  y   	: Y Koordinate (1-6)
//  cmin	: minimale Anzahl von Zeichen, die von einem berlangen
//			  Wort in seiner ersten Zeile dargestellt werden mssen,
//			  bevor es umgebrochen wird.
//	*dataptr: Datenpointer auf den String(im Flash), der ausgegeben
//			  werden soll.
void LcdOut_P(byte x,byte y,byte cmin,byte *dataptr)
	{
		byte xi,yi,length;
		xi=x;
		yi=y;
		LcdGotoXY(xi,yi);
		while(pgm_read_byte(dataptr)) //pgm_read_byte, da array im Flash
			{
			//delay_ms(100);
			if(pgm_read_byte(dataptr)!=0x20)			//Ausgabe
				{
				LcdChr(1,pgm_read_byte(dataptr));
				//LcdUpdate();
				if(xi==15)							//Cursor mitziehen						
						{
						xi=1;
						yi++;						//nchste Zeile
						}
					xi++;
				}
			else										//Zeilenumbruch wenn nchses
				{										//Wort weiter reicht als 14-z;
				length=1;
				//LcdUpdate();
				if(xi<=14 && xi>=1){xi++;}
				while(pgm_read_byte(dataptr+length)!=0x20) //Leerzeichen suchen 
					{
					length++;							//und Zeichen zhlen
					}
				if((length-1+xi)<=16){}
				else
					{
					if(yi==6){return;}
					if(length<=14)						//berlanges Wort erkennen
					    {
						xi=1;
						yi++;				//nchste Zeile
						}
					else{if(xi>=16-cmin){xi=1;yi++;}}
					}
				LcdGotoXY(xi,yi);
				}
			*dataptr++;									//Ein Zeichen weiter rcken
			}
	}



//--------------------------------One Wire Routinen--------------------------------------------

	
//---------------------------------Anzeigeroutinen---------------------------------------------


void AkkuAnzeige(double Ref,double Akt,bool mode)
	{
	double x;
	int i;
	LcdLine(0,1,38,1,mode);
	LcdLine(0,7,38,7,mode);
	LcdLine(0,1,0,7,mode);
	LcdLine(1,1,1,7,mode);
	LcdLine(37,1,37,7,mode);
	LcdLine(38,1,38,7,mode);
	LcdLine(39,3,39,5,mode);
	LcdLine(40,3,40,5,mode);
		
		x=(36*Akt)/Ref;
		if(x>=3)
			{
			LcdLine(3,3,x,3,mode);
			LcdLine(3,4,x,4,mode);
			LcdLine(3,5,x,5,mode);
			}
		if(x<=10){Normalbetrieb=0;Akkufastleer=1;}
	}
	
void Infotext(int Solltemp,int Isttemp)
	{
	char temp[4];
	LcdOut_P(1,3,3,Satz1);
	LcdOut_P(1,4,3,Satz2);
	LcdOut_P(1,5,3,Satz3);
	LcdOut_P(1,6,3,Satz4);
	
	itoa(Solltemp,temp,10);
	if(Solltemp<=9){LcdGotoXY(12,3);}
		else{LcdGotoXY(11,3);}
	LcdStr(1,temp);
	
	itoa(Isttemp,temp,10);
	if(Isttemp<=9){LcdGotoXY(12,4);}
		else{LcdGotoXY(11,4);}
	
	if(Isttemp>=Solltemp)
		{if(blinken==1)
			{LcdStr(1,temp);}
		}

	LcdOut_P(12,5,3,Ein);
	LcdOut_P(12,6,3,Ein);
	}



void Display()
	{
	if(Normalbetrieb==1)
		{
		LcdClear();
		AkkuAnzeige(1023,1023-i,1);
		Infotext(Solltemp,Isttemp);
		}
	
	if(Akkufastleer==1)
		{
		if(blinken==1)
			{
			LcdClear();
			AkkuAnzeige(1023,1023-i,1);
			Infotext(Solltemp,Isttemp);
			}
		else{
			LcdClear();
			AkkuAnzeige(1023,1023-i,0);
			Infotext(Solltemp,Isttemp);
			}
		}
	LcdUpdate();
	displaychanged=0;
	}
	
void Temperatursensor()
	{
	DS18X20_start_meas( DS18X20_POWER_PARASITE, NULL );
	delay_ms_mhz(DS18B20_TCONV_12BIT,uCClockMhz);
	DS18X20_read_meas_single(i, &subzero, &cel, &cel_frac_bits);
	}

//-----------------------------Anzeigeroutinen    Ende-----------------------------------------

void main(void)
{

set_sleep_mode(SLEEP_MODE_IDLE); //sleep mode 0
timer_init();
LcdInit();
delay_ms_mhz(30,uCClockMhz);
LcdInit();
LcdClear();
while(1){


if(displaychanged=1){Display();}


blinkzaehler++;	
if(blinkzaehler>=10)
	{blinkzaehler=0;
	if(blinken==0)
		{blinken=1;displaychanged=1;}
		else{blinken=0;displaychanged=1;}
	}

delay_ms_mhz(10,uCClockMhz);
i+=1;
if(i>=1023){i=0;Normalbetrieb=1;Akkufastleer=0;}

//display_power_down();
//delay_ms_mhz(5000,uCClockMhz);
//display_power_up();

}
}
